<html>
<head>
    <meta charset="utf-8">
    <title>Datenbank Datensatz ändern</title>
    <link rel='stylesheet' href='khsw.css'>
</head>
<body>
<?php // ********** ab hier PHP **********
// Kopfzeile einbinden
include "khsw.php";
// ************************************************************************************************
// POST-Variablen auslesen
// ************************************************************************************************
echo "Liste aller POST-Variablen<br>";
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    foreach($_POST as $key => $value) {
        $value = trim($value);
        $value = stripslashes($value);
        $value = htmlspecialchars($value);
        $$key=$value;
        echo '$_POST["'.$key.'"]="'.$value.'"<br>';
    }
}
// ************************************************************************************************
// Verbindung zum Server aufbauen, Datenbank, Tabelle auswählen
// ************************************************************************************************
// persönliche Konfigurationsdaten einbinden
include "config.inc.php";
// Datenbanknamen und Tabelle festlegen, falls nicht per POST übergeben
if (empty($database)) $database=$username."_politik";
if (empty($table)) $table="bundeskanzler";
// Verbindung zum Datenbankserver definieren
$conn = new mysqli($servername, $username, $password);
// Verbindung zum Server prüfen
if ($conn->connect_error) { // Abbruch bei Fehler
  die("<p>Verbindung zum Server ".$servername." misslungen: " . $conn->connect_error."<p>\n");
}
// Zeichensatz utf-8 für die Verbindung zum Server einstellen
$conn->set_charset('utf8');
// Verbindung zur Datenbank aufbauen
$sql="USE $database";
if ($conn->query($sql) === TRUE) {
    echo "<p>Verbindung zur Datenbank $database erfolgreich.</p>\n";
} else {
    die("<p>Fehler bei der Verbindung zur Datenbank $database: " . $conn->error."</p>\n");
}
// Datentypen aus der Tabelle auslesen
$sql = "SHOW COLUMNS FROM $table;";
$result = $conn->query($sql);
while ($row = $result->fetch_assoc()) {
    $datatype[$row["Field"]]=$row["Type"];
}
// Datensatz aus der Tabelle auslesen
$sql = "SELECT * FROM $table WHERE $where;";
echo "<p>Tabelle $table, SQL-Befehl: $sql</p>";
$result = $conn->query($sql);
// ************************************************************************************************
// Eingabemaske anzeigen
// ************************************************************************************************
    if ($result->num_rows > 0) {
        // Die Tabelle hat Inhalt: FORM und HTML-Tabelle vorbereiten
        // die form umschließt alles
        echo "<form action='edit-change.php' method='post'>\n";
        // In der Tabelle werden alle Eingabefelder systematisch dargestellt
        echo "<table>";
        echo "<tr><th>Eigenschaft</th><th>Wert</th></tr>\n";
        // Hier müssen die Daten des Datensatzes in Eingabefeldern dargestellt werden
        $row=$result->fetch_assoc(); // Datensatz auslesen, es ist genau einer
        foreach ($row as $key => $value) {
            // Feststellen, ob die Eigenschaft ein Fremdschlüssel ist
            $rel_sql="SELECT u.REFERENCED_TABLE_NAME `table`, u.REFERENCED_COLUMN_NAME `column` FROM information_schema.KEY_COLUMN_USAGE u INNER JOIN information_schema.REFERENTIAL_CONSTRAINTS c ON u.CONSTRAINT_SCHEMA=c.CONSTRAINT_SCHEMA AND u.CONSTRAINT_NAME=c.CONSTRAINT_NAME WHERE u.TABLE_SCHEMA='$database' AND u.TABLE_NAME='$table' and u.COLUMN_NAME='$key'";
            $rel_result=$conn->query($rel_sql);
            if ($rel_result->num_rows>0) {
                $rel_row=$rel_result->fetch_assoc();
                $rel_table=$rel_row["table"];
                $rel_column=$rel_row["column"];
            } else {
                $rel_table=""; $rel_column="";
            }
            // Tabellenzeile mit Eingabefeld aufbauen
            echo "<tr><td>$key</td>";
            echo "<td>";
            if ($rel_table>"" AND $rel_column>"") { // Fremdschlüssel: zuöässige Werte bestimmen
                $rel_sql="SELECT * FROM $rel_table";
                $rel_result=$conn->query($rel_sql);
                $rel_list=array();
                $rel_label=$rel_column; // Beschriftungsspalte ist erstmal der Primärschlüssel selbst
                if ($rel_result->num_rows>0) {
                    $rel_row=$rel_result->fetch_assoc();
                    if (isset($rel_row["Bezeichnung"])) {
                        $rel_label="Bezeichnung";
                    } else if (isset($rel_row["Name"])) {
                        $rel_label="Name";
                    }
                    do {
                        $rel_list[$rel_row[$rel_column]]=$rel_row[$rel_label];
                    } while ($rel_row=$rel_result->fetch_assoc());
                }
                echo "<select name='in-$key'>";
                foreach($rel_list as $k => $v) {
                    if ($k==$value) { $c=" selected"; } else { $c=""; }
                    echo "<option value='$k'$c>$v</option>\n";
                }
                echo "</select>\n";
            } else if (substr($datatype[$key],0,3)=="int" || substr($datatype[$key],0,6)=="bigint") {
                echo "<input type='number' name='in-$key' value='$value'>";
            } else if (substr($datatype[$key],0,4)=="date") {
                echo "<input type='date' name='in-$key' value='$value'>";
            } else if (substr($datatype[$key],0,8)=="datetime") {
                echo "<input type='datetime-local' name='in-$key' value='$value'>";
//            } else if (substr($datatype[$key],0,4)=="enum") {
//                foreach()
//                echo "<input type='radio' name='in-$key'";
//                if ($key==$value) { echo " checked='checked'"; }
//                echo ">";
            } else { // am Enden: einfach Text
                echo "<input type='text' name='in-$key' value='$value'>";
            }
            echo "</td></tr>\n";
        }
        echo "<tr><td>&nbsp;</td><td>\n";
        echo "<input type='hidden' name='database' value='$database'>\n";
        echo "<input type='hidden' name='table'    value='$table'>\n";
        echo "<input type='hidden' name='where'    value=\"$where\">\n";
        echo "<button>Ändern</button>\n";
        echo "</td></tr></table>\n";
        echo "</form>\n";
    }
    else {
        echo "<p>Kein Datensatz vorhanden.</p>";
    }
// ************************************************************************************************
// Verbindung zum Datenbankserver schließen
$conn->close();
echo "<form action='table.php' method='post'>\n";
echo "<input type='hidden' name='database' value='$database'>\n";
echo "<input type='hidden' name='table' value='$table'>\n";
echo "<button>Tabelle anzeigen</button>\n";
echo "</form>\n";
echo "<form action='index.php' method='post'>\n";
echo "<input type='hidden' name='database' value='$database'>\n";
echo "<button>Liste der Tabellen anzeigen</button>\n";
echo "</form>\n";
?> 
</body>
</html>